
/******************************************************************************
 * @file     Smpl_Main.c
 * @brief    Nano1xx NUTINY-EVB_NANO130 LCD Demo code
 * @version  1.0.1
 * @date     04, September, 2012
 *
 * @note
 * Copyright (C) 2012-2014 Nuvoton Technology Corp. All rights reserved.
 ******************************************************************************/
#include "nano1xx.h"
#include "nano1xx_lcd.h"
#include "DrvLcd_1.h"
uint32_t g_u32hiMin,g_u32loMin,g_u32hiSec,g_u32loSec ;

void delay(void)
{
  uint32_t i;
  for(i=0;i<2000;i++);
}

void RTC_IRQHandler()
{
	/* RTC Tick interrupt */
	if (RTC->RIIR & RTC_RIIR_TIS)		
	{
		RTC->RIIR   = RTC_RIIR_TIS;
		g_u32hiMin  =  ((RTC->TLR & RTC_TLR_TEN_MIN) >> 12)&0x0F;
	    g_u32loMin  =  ((RTC->TLR & RTC_TLR_MIN) >> 8)&0x0F;
	    g_u32hiSec  =  ((RTC->TLR & RTC_TLR_TEN_SEC) >> 4)&0x0F;
	    g_u32loSec  =  (RTC->TLR & RTC_TLR_SEC)&0x0F;
	    
		Lcd_Show(6,g_u32loSec) ;
		Lcd_Show(5,g_u32hiSec) ;
		
		Lcd_Show(3,g_u32loMin) ;
		Lcd_Show(2,g_u32hiMin) ;
    }
}


int32_t main(void)							   
{
 	UNLOCKREG();
    CLK->PWRCTL |= CLK_PWRCTL_LXT_EN;  	     
    while((CLK->CLKSTATUS & CLK_PWRCTL_LXT_EN) == 0); 
	CLK->PWRCTL &= ~CLK_PWRCTL_LIRC_EN; 	
    LOCKREG();
	
//=================Init LCD==================================
    CLK->CLKSEL1 &=~CLK_CLKSEL1_LCD_LIRC;	   //ѡLXTΪʱԴ
   	CLK->APBCLK  = CLK_APBCLK_LCD_EN ;                    // LCD ʱʹ
	GCR->IPRST_CTL2|=GCR_IPRSTCTL2_LCD ;
	GCR->IPRST_CTL2&=~GCR_IPRSTCTL2_LCD ;

    LCD->CTL     = LCD_CTL_PDDISP_EN                       // ģʽȻʾ
                 | LCD_FREQ_DIV128                          // LCDʱ 32Ƶ
                 | LCD_MUX_ONE_FOURTH                      // 4-MUX
                 | LCD_CTL_EN ;                            // LCD ʹ

	LCD->DISPCTL = LCD_CPUMP_DIV1                          //ʹ
                 | LCD_CPVOl_3V                            //LCDѹ 3V
                 | LCD_BIAS_THIRD                          //1/3ƫѹ
                 | LCD_DISPCTL_CPUMP_EN ;                  //ʹ

	MFP_LCD_TYPEA();        /* Select LCD COMs, SEGs, V1 ~ V3, DH1, DH2 */	
	
	GCR->PF_L_MFP &=0xFFFFFF00;  // ICEΪGPIOģʽ
	GPIOF->PUEN |=0x03;          //ʹ ICE 
	  	
	GPIOA->OFFD |= 0xFFFF0000;
	GPIOB->OFFD |= 0xFFFF0000;
	GPIOC->OFFD |= 0xFFFF0000;
	GPIOD->OFFD |= 0xFFFF0000;
	GPIOE->OFFD |= 0xFFFF0000;
	GPIOF->OFFD |= 0xFFFC0000;  //ICE: PF0 PF1ʹܹܲ
//=================Init RTC==================================
	CLK->APBCLK |= CLK_APBCLK_RTC_EN;	

	RTC->INIR = 0xA5EB1357;			//λRTC
	while((RTC->INIR&0x1) == 0x0); 	
	RTC->AER = 0xA965;
	while((RTC->AER&RTC_AER_ENF) == 0x0); //ʹRTCĴ

	RTC->CLR=0x140409;	 //ʼǰ
	RTC->DWR=0x03;		 //ʼǰ
	RTC->TSSR=0x01;	     //24Сʱ
	RTC->TLR=0x000000;	 //ʼǰʱ
	RTC->TTR =	RTC_TTR_TWKE|0;  //Tick one second
	RTC->RIER |= RTC_RIER_TIER; 	
	NVIC->ISER[0] = (1 << (RTC_IRQn & 0x1F)); 
	RTC->AER = 0;

	delay();
	g_u32hiMin  =  ((RTC->TLR & RTC_TLR_TEN_MIN) >> 12)&0x0F;
    g_u32loMin  =  ((RTC->TLR & RTC_TLR_MIN) >> 8)&0x0F;
    g_u32hiSec  =  ((RTC->TLR & RTC_TLR_TEN_SEC) >> 4)&0x0F;
    g_u32loSec  =  (RTC->TLR & RTC_TLR_SEC)&0x0F;
    
	Lcd_Show(6,g_u32loSec) ;
	Lcd_Show(5,g_u32hiSec) ;
	
	Lcd_Show(3,g_u32loMin) ;
	Lcd_Show(2,g_u32hiMin) ;
	
	
//	GPIOE->PMD   =  (GPIOE->PMD & ~GPIO_PMD_PMD6_MASK | GPIO_PMD_PMD6_OUTPUT) ;
	while (1)
	{
		UNLOCKREG();	                                      
	    CLK->PWRCTL |= CLK_PWRCTL_PWRDOWN_EN;	               // ÿζҪ1
	    SCB->SCR  |= 0x04 ;	
		LOCKREG();                                             
	    __WFI() ;		
		__nop();
//		GPIOE->DOUT^=0x40;                                     // LED˸ 	
	}
}

void SystemInit(void)
{
}
